/// DELETE FREOPEN!!!


#define _CRT_SECURE_NO_DEPRECATE
#pragma comment(linker,"/STACK:64000000")

#include <iostream>
#include <sstream>
#include <stdio.h>
#include <memory.h>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <deque>
#include <stack>
#include <cassert>
#include <time.h>
#include <bitset>

using namespace std;

#define mp make_pair
#define pb push_back
#define _(a,b) memset( (a), b, sizeof( a ) )
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

typedef unsigned long long ull;
typedef long long lint;
typedef pair < int , int > pii;
typedef long double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = 1000000000000000000LL;
const double eps = 1e-9;

vector<string> SplitByChar(string str, char separator)
{
	vector<string> res;
	int pos = 0;
	int len = 0;
	for (int i = 0; i < (int)str.size(); i++)
	{
		if (str[i] == separator)
		{
			res.push_back(str.substr(pos, len));
			pos = i+1;
			len = 0;
		}
		else len++;
	}
	if (len != 0)
	{
		res.push_back(str.substr(pos, len));
	}
	return res;
}

int ParseInt(string str)
{
	int res = 0;
	for (int i = 0; i < (int)str.size(); i++)
	{
		if (isdigit(str[i]))
			res = res*10 + (str[i] - '0');
	}
	return res;
}

vector<int> Split(string str)
{
	vector<string> args = SplitByChar(str, ' ');
	vector<int> res;
	for (int i = 0; i < (int)args.size(); i++)
	{
		if (args[i].size() != 0)
			res.push_back(ParseInt(args[i]));
	}
	return res;
}

struct Point
{
	int x, y;

	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}

	bool operator ==(Point p)
	{
		return x == p.x && y == p.y;
	}

	bool operator <(const Point &p) const
	{
		return x < p.x || x == p.x && y < p.y;
	}
};

const int lines = 14;
const int columns = 20;
const int goalLength = 4;
const int goalStart = ((lines - goalLength) / 2);
const int goalFinish = goalStart + goalLength;
const int maxDep = 2;

int ourColumn, enemyColumn;
bool moves[lines+1][columns+1][lines+1][columns+1];
int x, y;
bool occuped[lines + 1][columns + 1];

int MovesCount(int x, int y)
{
	int res = 0;
	for (int i = 0; i <= lines; i++)
		for (int j = 0; j <= columns; j++)
			if (moves[x][y][i][j])
				res++;
	return res;
}

void Fill(vector<Point> v)
{
	for (int i = 1; i < (int)v.size(); i++)
	{
		moves[v[i].x][v[i].y][v[i - 1].x][v[i - 1].y] = true;
		moves[v[i - 1].x][v[i - 1].y][v[i].x][v[i].y] = true;
	}

	for (int i = 0; i < sz(v); i++)
		occuped[v[i].x][v[i].y] = true;

	x = v[v.size() - 1].x;
	y = v[v.size() - 1].y;
}

void MakeEnemyMove(string str)
{
	vector<int> nums = Split(str);
	int moveLen = nums[0];
	vector<Point> points;
	for (int i = 0; i < moveLen; i++)
	{
		int x = nums[i * 2 + 1];
		int y = nums[i * 2 + 2];
		points.push_back(Point(x, y));
	}
	Fill(points);
}

bool mark[lines+1][columns+1];
Point parent[lines+1][columns+1];
int resx, resy;
double resGoodness;
vector<Point> resPath, curPath;
vector<pair<double, Point> > bestPoints;

void InitDfs()
{
	memset(mark, 0, sizeof(mark));
	resx = -1;
	resy = -1;
	resGoodness = (double)(-LINF - LINF);
	bestPoints.clear();
}

int d[8][2]  = {{-1, -1}, {-1, 0}, {-1, 1}, {0, -1}, {0, 1}, {1, -1}, {1, 0}, {1, 1}};

deque<Point> q;
int dist[lines + 1][columns + 1];

bool inside(const Point &t)
{
	return
		t.x >= 0 && t.x <= lines &&
		t.y >= 0 && t.y <= columns;
}

void bfsToGoals(int x, int y)
{
	while (!q.empty())
		q.pop_front();

	_(dist, 127);
	q.push_front(Point(x, y));
	dist[x][y] = 0;
	while (!q.empty())
	{
		Point p = q.front();
		q.pop_front();
		for (int i = 0; i < 8; i++)
		{
			Point t(p.x + d[i][0], p.y + d[i][1]);
			if (inside(t))
			{
				int len = MovesCount(p.x, p.y) != 0 && MovesCount(t.x, t.y) != 0 ? 0 : 1;// occuped[p.x][p.y] && occuped[t.x][t.y] ? 0 : 1;
				if (dist[t.x][t.y] > dist[p.x][p.y] + len)
				{
					dist[t.x][t.y] = dist[p.x][p.y] + len;
					if (len)
						q.push_back(t);
					else
						q.push_front(t);
				}
			}
		}
	}
}

bool winPosition(int x, int y)
{
	if (y == enemyColumn && x > 5 && y < 9)
		return true;
	bfsToGoals(x, y);
	for (int i = 0; i <= lines; i++)
	{
		for (int j = 0; j <= columns; j++)
		{
			if (MovesCount(i, j) == 0 && dist[i][j] < INF)
				return false;
		}
	}
	return true;
}

bool losePosition(int x, int y)
{
	return y == ourColumn && x > 5 && y < 9;
}

double goodnessFun(int x, int y)
{
	if (winPosition(x, y))
		return (double)LINF;
	if (losePosition(x, y))
		return (double)(-LINF);
	bfsToGoals(x, y);
	int m1 = INF, m2 = INF;
	for (int i = 6; i <= 8; i++)
	{
		m1 = min(dist[i][ourColumn], m1);
		m2 = min(dist[i][enemyColumn], m2);
	}
	int distToOurGoals = abs(y - ourColumn);
	double k1 = 1;
	double k2 = 1;
	double k3 = 1;
	double s1 = m1;//sqrt((double)m1);
	double s2 = m2;//sqrt((double)m2);
	double s3 = distToOurGoals;//sqrt((double)distToOurGoals);
	double res = k1 * s1 - k2 * s2 + k3 * s3;
	return res;
}

int counter;
bool markEnemy[lines + 1][columns + 1];
double DfsEnemy(int curx, int cury, int lastx, int lasty)
{
	double best = LINF + LINF;
	if (counter <= 0)
		return best;
	markEnemy[curx][cury] = true;
	for (int dir = 0; dir < 8; dir++)
	{
		int dx = d[dir][0];
		int dy = d[dir][1];
		int x = curx + dx;
		int y = cury + dy;
		if (x < 0 || x > lines || y < 0 || y > columns) continue;
		if (!moves[curx][cury][x][y] && !markEnemy[x][y])
		{
			if (MovesCount(x, y) == 0)
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				markEnemy[x][y] = true;
				counter--;
				best = min(best, goodnessFun(x, y));

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
			else
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				best = min(best, DfsEnemy(x, y, curx, cury));

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
		}
	}
	return best;
}

bool inOurGoals(int x, int y)
{
	return y == ourColumn && x > 5 && x < 9;
}

bool inEnemyGoals(int x, int y)
{
	return y == enemyColumn && x > 5 && x < 9;
}

void Dfs(int curx, int cury, int lastx, int lasty)
{
	mark[curx][cury] = true;
	curPath.pb(Point(curx, cury));
	parent[curx][cury] = Point(lastx, lasty);
	for (int dir = 0; dir < 8; dir++)
	{
		int dx = d[dir][0];
		int dy = d[dir][1];
		int x = curx + dx;
		int y = cury + dy;
		if (x < 0 || x > lines || y < 0 || y > columns) continue;
		if (!moves[curx][cury][x][y] && !mark[x][y])
		{
			if (MovesCount(x, y) == 0 || inOurGoals(x, y) || inEnemyGoals(x, y))
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				mark[x][y] = true;
				_(markEnemy, 0);
				double goodness = goodnessFun(x, y);
				bestPoints.pb(mp(goodness, Point(x, y)));
				//if (resGoodness < goodness)
				//{
				//	resx = x;
				//	resy = y;
				//	resGoodness = goodness;
				//	resPath = curPath;
				//	resPath.pb(Point(x, y));
				//}

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
			else
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				Dfs(x, y, curx, cury);

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
		}
	}
	curPath.pop_back();
}

double goodNessBound;
void Dfs2(int curx, int cury, int lastx, int lasty)
{
	mark[curx][cury] = true;
	curPath.pb(Point(curx, cury));
	parent[curx][cury] = Point(lastx, lasty);
	for (int dir = 0; dir < 8; dir++)
	{
		int dx = d[dir][0];
		int dy = d[dir][1];
		int x = curx + dx;
		int y = cury + dy;
		if (x < 0 || x > lines || y < 0 || y > columns) continue;
		if (!moves[curx][cury][x][y] && !mark[x][y])
		{
			if (MovesCount(x, y) == 0 || inOurGoals(x, y) || inEnemyGoals(x, y))
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				mark[x][y] = true;
				_(markEnemy, 0);
				double goodness = goodnessFun(x, y);
				if (goodness >= goodNessBound - eps)
				{
					counter = 5;
					goodness = DfsEnemy(x, y, -1, -1);
					if (resGoodness < goodness)
					{
						resx = x;
						resy = y;
						resGoodness = goodness;
						resPath = curPath;
						resPath.pb(Point(x, y));
					}
				}

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
			else
			{
				moves[curx][cury][x][y] = true;
				moves[x][y][curx][cury] = true;

				Dfs2(x, y, curx, cury);

				moves[curx][cury][x][y] = false;
				moves[x][y][curx][cury] = false;
			}
		}
	}
	curPath.pop_back();
}

vector<Point> CollectMove(int x, int y)
{
	vector<Point> res;
	while (!(x == -1 && y == -1))
	{
		Point p = Point(x, y);
		res.push_back(p);
		x = parent[p.x][p.y].x;
		y = parent[p.x][p.y].y;
	}
	reverse(res.begin(), res.end());
	return res;
}

int test = 0;

void MakeMove()
{
	InitDfs();
	Dfs(x, y, -1, -1);

	sort(all(bestPoints));
	reverse(all(bestPoints));
	int gg = min(3, sz(bestPoints));
	goodNessBound = bestPoints[gg - 1].first;

	InitDfs();
	Dfs2(x, y, -1, -1);

	vector<Point> myMove = resPath; 
	printf("%d", myMove.size());
	for (int i = 0; i < (int)myMove.size(); i++)
		printf(" %d %d", myMove[i].x, myMove[i].y);
	printf("\n");
	Fill(myMove);
}

void FillEdge(int x1, int y1, int x2, int y2)
{
	if (x1 < 0 || x1 > lines) return;
	if (x2 < 0 || x2 > lines) return;
	if (y1 < 0 || y1 > columns) return;
	if (y2 < 0 || y2 > columns) return;
	moves[x1][y1][x2][y2] = true;
	occuped[x1][y1] = true;
	occuped[x2][y2] = true;
}

void InitField(bool enemyFirst)
{
	x = lines / 2;
	y = columns / 2;
	ourColumn = enemyFirst ? columns : 0;
	enemyColumn = enemyFirst ? 0 : columns;

	for (int i = 0; i <= lines; i++)
	{
		if (i <= goalStart || i >= goalFinish)
		{
			FillEdge(i, 0, i - 1, 0);
			FillEdge(i, columns, i - 1, columns);
			FillEdge(i, 0, i + 1, 0);
			FillEdge(i, columns, i + 1, columns);
		}
	}
	for (int j = 0; j <= columns; j++)
	{
		FillEdge(0, j, 0, j - 1);
		FillEdge(0, j, 0, j + 1);
		FillEdge(lines, j, lines, j - 1);
		FillEdge(lines, j, lines, j + 1);
	}
}

char buf[1000];
void Run()
{
	bool firstMove = true;	
	while (true)
	{
		gets(buf);
		string str = string(buf);
		if (str == "Quit")
			return;
		if (str == "Name")
		{
			printf("CynepMyTaHT\n");
			fflush(stdout);
			continue;
		}
		if (str != "Start")
		{
			if (firstMove)
			{
				InitField(true);
				firstMove = false;
			}
			MakeEnemyMove(str);
		}
		if (firstMove)
		{
			InitField(false);
			firstMove = false;
		}
		MakeMove();
		fflush(stdout);
		//gets(buf);
	}
}

int main()
{
	//freopen("game.pgn", "r", stdin);
	Run();
	return 0;
}