#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <time.h>

using namespace std;

int curstep = 0;
int lasttime;


int ParseInt(string str)
{
	int res = 0;
	int s = str.size();
	for (int i = 0; i < s; i++)
			res = res*10 + (str[i] - '0');
	return res;
}

unsigned char first_state[3][3] = {{128,64,32},{1,0,16},{2,4,8}};
unsigned char second_state[3][3] = {{8,4,2},{16,0,1},{32,64,128}};
unsigned char st[8] = {1,2,4,8,16,32,64,128};
char moves[8][2] = {{0,-1},{1,-1},{1,0},{1,1},{0,1},{-1,1},{-1,0},{-1,-1}};

struct Point
{
	int x,y;
};

struct state
{
	unsigned char map[21][15];
	char cur_x;
	char cur_y;
	vector<char> way;
};


state Global_area;
bool go_to_right;

int is_end(state& n)
{
	int max_reb;
	if((n.cur_x == 0) || (n.cur_x == 20))
	{
		if((n.cur_y == 0) || (n.cur_y == 14))
			max_reb = 1;
		else
			max_reb = 3;
	}
	else
	{
		if((n.cur_y == 0) || (n.cur_y == 14))
			max_reb = 3;
		else
			max_reb = 8;
	}
	int reb_count = 0;
	for(int i=0;i!=8;i++)
		if((n.map[n.cur_x][n.cur_y] & st[i]) != 0)
			reb_count++;
	if(max_reb == 1)
		return -1;
	if(max_reb == 3)
	{
		if((n.cur_y>5 && n.cur_y<9))
			if((go_to_right && n.cur_x == 20) || (!go_to_right && n.cur_x == 0))
				return 1;
		return -1;
	}
	if(reb_count == 8)
		return 1;
	if(reb_count == 1)
		return 0;
	return -1;
}



void Inicialize()
{
	for(int i=0;i!=21;i++)
		for(int j=0;j!=15;j++)
			Global_area.map[i][j] = 0;
	Global_area.cur_x = 10;
	Global_area.cur_y = 7;
}

void Refresh_map(vector<Point> v)
{
	for(int i=0;i != (int) v.size()-1;i++)
	{
		int r_x = v[i+1].x - v[i].x;
		int r_y = v[i+1].y - v[i].y;
		Global_area.map[v[i].x][v[i].y] += first_state[r_x+1][r_y+1];
		Global_area.map[v[i+1].x][v[i+1].y] += second_state[r_x+1][r_y+1];
	}
	Global_area.cur_x = v[v.size()-1].x;
	Global_area.cur_y = v[v.size()-1].y;
	Global_area.way.clear();

}


string make_answ(state s)
{
	string answ = "";
	char buf[10000];
	sprintf(buf,"%d ",s.way.size()+1);
	answ += string(buf);
	sprintf(buf,"%d %d ",Global_area.cur_y,Global_area.cur_x);
	answ+=string(buf);
	int c_x = Global_area.cur_x,c_y = Global_area.cur_y;
	for(int i=0;i!=s.way.size();i++)
	{
		c_x += moves[s.way[i]][0];
		c_y += moves[s.way[i]][1];
		sprintf(buf,"%d %d ",c_y,c_x);
		answ+=string(buf);
	}
	Global_area = s;
	return answ;
}

void Make_step()
{
	state top;
		int great = go_to_right ? -1 : 100;
		int otkl = 123;
	int last = time(0);
	vector<state> answ;
	bool wasansw = false;
	state answ100proc;
	queue<state> q;
	q.push(Global_area);

	while(!q.empty())
	{
		state now = q.front();
		q.pop();
		for(int i=0;i!=8;i++)
		{
			if(((now.map[now.cur_x][now.cur_y] & st[i]) == 0) 
				&& !((now.cur_x == 0) && ((i == 0) || (i > 3))) 
				&& !((now.cur_x == 20) && ((i == 0) || (i < 5))) 
				&& !((now.cur_y == 0) && ((i < 3) || (i > 5)))
				&& !((now.cur_y == 14) && ((i > 1) && (i < 7))))
			{
				state n = now;
				n.map[now.cur_x][now.cur_y] += st[i];
				unsigned char rev_st = (st[i]>8) ? st[i]/16 : st[i]*16; 
				n.map[now.cur_x + moves[i][0]][now.cur_y + moves[i][1]] += rev_st;
				n.cur_x = now.cur_x + moves[i][0];
				n.cur_y = now.cur_y + moves[i][1];
				n.way.push_back((char)i);
				int e = is_end(n);
				if(e == 1)
				{
					top = n;
					goto exit;
				}
				else
				{
					if(e == 0)
					{
						wasansw = true;
						if(go_to_right)
						{
							if(n.cur_x>great || (n.cur_x==great && (abs(5-n.cur_y) <= otkl)))
							{
								great = n.cur_x;
								top = n;
								otkl = abs(7-n.cur_y);
							}
						}
						else
						{
							if(n.cur_x<great || (n.cur_x==great && (abs(5-n.cur_y) <= otkl)))
							{
								great = n.cur_x;
								top = n;
								otkl = abs(7-n.cur_y);
							}
						}
						if(time(0)-last > 100)
							goto exit;
					}
					else
						q.push(n);
				}
			}
		}
	}
exit:
	string send = make_answ(top);
	printf("%s\n",send.c_str());
	fflush(stdout);
}

void main()
{
	char buf[1000];
	go_to_right = false;
	while (1) 
	{
		scanf("%s",&buf);
		string str = string(buf);
		if (str == "Quit")
			return;
		if (str == "Name") 
		{
			printf("PSUToGoalKeeperCpp\n");
			fflush(stdout);
			Inicialize();
		}
		else
		{
			if(str == "Start")
			{
				go_to_right = true;
				Make_step();
			}
			else
			{
				int count = ParseInt(str);
				vector<Point> v;
				for(int i=0;i!=count;i++)
				{
					Point now;
					scanf("%d %d",&now.y,&now.x);
					v.push_back(now);
				}
				Refresh_map(v);
				Make_step();
			}
		}
	}
}